---
title: ServiceWorkerMessageEvent.ports
slug: Web/API/ServiceWorkerMessageEvent/ports
tags:
  - API
  - Deprecated
  - Experimental
  - Property
  - Reference
  - Service Workers
  - ServiceWorkerMessageEvent
  - ports
---
<p>{{APIRef("Service Workers API")}}{{deprecated_header}}</p>

<div class="warning">
<p><strong>Important</strong>: In modern browsers, this property has been deprecated. Service worker messages will now use the {{domxref("MessageEvent")}} interface, for consistency with other web messaging features.</p>
</div>

<p>The <font face="Consolas, Liberation Mono, Courier, monospace"><strong>ports</strong></font> read-only property of the {{domxref("ServiceWorkerMessageEvent")}} interface returns an array of {{domxref("MessagePort")}} objects connected with the message channel the message is being sent through.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var myPorts = ServiceWorkerMessageEventInstance.ports;</pre>

<h3 id="Value">Value</h3>

<p>An array of {{domxref("MessagePort")}} objects.</p>

<h2 id="Examples">Examples</h2>

<p>When the following code is used inside the main thread to set up a message channel between it and a service worker for sending messages between the two, the event object of <code>onmessage</code> will be a <code>ServiceWorkerMessageEvent</code>.</p>

<pre class="brush: js">navigator.serviceWorker.ready.then(function(reg) {

  ...

      // set up a message channel to communicate with the SW
      var channel = new MessageChannel();
      channel.port1.onmessage = function(e) {
        console.log(e.ports);
        handleChannelMessage(e.data);
      }

      mySW = reg.active;
      mySW.postMessage('hello', [channel.port2]);
  });</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ServiceWorkerMessageEvent.ports")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li><a class="external external-icon" href="https://github.com/mdn/sw-test">Service workers basic code example</a></li>
 <li><a class="external external-icon" href="https://jakearchibald.github.io/isserviceworkerready/">Is ServiceWorker ready?</a></li>
 <li><a href="/en-US/docs/Web/API/Channel_Messaging_API">Channel Messaging</a></li>
</ul>
